/*
 * Copyright (c) 2005-2008 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.chain.tools;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IProgressMonitor;

import fr.obeo.acceleo.tools.resources.Resources;

/**
 * The default post generation action.
 * 
 * @author www.obeo.fr
 * 
 */
public class DefaultPostGeneration implements IPostGeneration {

	/* (non-Javadoc) */
	public void postFileGeneration(IContainer target, IPath path, StringBuffer content, IProgressMonitor monitor) throws CoreException {
		Resources.createFile(target, path, content.toString(), monitor);
	}

	/* (non-Javadoc) */
	public void postProcessing(IProgressMonitor monitor) {
	}

}
