/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.AssociationEndRole;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.AttributeLink;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml13.foundation.core.Attribute;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.Classifier;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.data_types.Expression;
import fr.obeo.acceleo.uml13.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Attribute</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AttributeImpl#getInitialValue
 * <em>Initial Value</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AttributeImpl#getAssociationEnd
 * <em>Association End</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AttributeImpl#getAttributeLink
 * <em>Attribute Link</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AttributeImpl#getAssociationEndRole
 * <em>Association End Role</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class AttributeImpl extends StructuralFeatureImpl implements Attribute {
	/**
	 * The cached value of the '{@link #getInitialValue()
	 * <em>Initial Value</em>}' containment reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getInitialValue()
	 * @generated
	 * @ordered
	 */
	protected Expression initialValue = null;

	/**
	 * The cached value of the '{@link #getAttributeLink()
	 * <em>Attribute Link</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getAttributeLink()
	 * @generated
	 * @ordered
	 */
	protected EList attributeLink = null;

	/**
	 * The cached value of the '{@link #getAssociationEndRole()
	 * <em>Association End Role</em>}' reference list. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getAssociationEndRole()
	 * @generated
	 * @ordered
	 */
	protected EList associationEndRole = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AttributeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CorePackage.eINSTANCE.getAttribute();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Expression getInitialValue() {
		return initialValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetInitialValue(Expression newInitialValue, NotificationChain msgs) {
		Expression oldInitialValue = initialValue;
		initialValue = newInitialValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.ATTRIBUTE__INITIAL_VALUE, oldInitialValue, newInitialValue);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setInitialValue(Expression newInitialValue) {
		if (newInitialValue != initialValue) {
			NotificationChain msgs = null;
			if (initialValue != null)
				msgs = ((InternalEObject) initialValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.ATTRIBUTE__INITIAL_VALUE, null, msgs);
			if (newInitialValue != null)
				msgs = ((InternalEObject) newInitialValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.ATTRIBUTE__INITIAL_VALUE, null, msgs);
			msgs = basicSetInitialValue(newInitialValue, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ATTRIBUTE__INITIAL_VALUE, newInitialValue, newInitialValue));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationEnd getAssociationEnd() {
		if (eContainerFeatureID != CorePackage.ATTRIBUTE__ASSOCIATION_END)
			return null;
		return (AssociationEnd) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAssociationEnd(AssociationEnd newAssociationEnd) {
		if (newAssociationEnd != eContainer || (eContainerFeatureID != CorePackage.ATTRIBUTE__ASSOCIATION_END && newAssociationEnd != null)) {
			if (EcoreUtil.isAncestor(this, newAssociationEnd))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newAssociationEnd != null)
				msgs = ((InternalEObject) newAssociationEnd).eInverseAdd(this, CorePackage.ASSOCIATION_END__QUALIFIER, AssociationEnd.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newAssociationEnd, CorePackage.ATTRIBUTE__ASSOCIATION_END, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ATTRIBUTE__ASSOCIATION_END, newAssociationEnd, newAssociationEnd));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAttributeLink() {
		if (attributeLink == null) {
			attributeLink = new EObjectWithInverseResolvingEList(AttributeLink.class, this, CorePackage.ATTRIBUTE__ATTRIBUTE_LINK, Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE);
		}
		return attributeLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAssociationEndRole() {
		if (associationEndRole == null) {
			associationEndRole = new EObjectWithInverseResolvingEList.ManyInverse(AssociationEndRole.class, this, CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE,
					CollaborationsPackage.ASSOCIATION_END_ROLE__AVAILABLE_QUALIFIER);
		}
		return associationEndRole;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.ATTRIBUTE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.ATTRIBUTE__NAMESPACE, msgs);
			case CorePackage.ATTRIBUTE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case CorePackage.ATTRIBUTE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__OWNER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.ATTRIBUTE__OWNER, msgs);
			case CorePackage.ATTRIBUTE__ASSOCIATION_END:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.ATTRIBUTE__ASSOCIATION_END, msgs);
			case CorePackage.ATTRIBUTE__ATTRIBUTE_LINK:
				return ((InternalEList) getAttributeLink()).basicAdd(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE:
				return ((InternalEList) getAssociationEndRole()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.ATTRIBUTE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__NAMESPACE:
				return eBasicSetContainer(null, CorePackage.ATTRIBUTE__NAMESPACE, msgs);
			case CorePackage.ATTRIBUTE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__BINDING:
				return basicSetBinding(null, msgs);
			case CorePackage.ATTRIBUTE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case CorePackage.ATTRIBUTE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__OWNER:
				return eBasicSetContainer(null, CorePackage.ATTRIBUTE__OWNER, msgs);
			case CorePackage.ATTRIBUTE__MULTIPLICITY:
				return basicSetMultiplicity(null, msgs);
			case CorePackage.ATTRIBUTE__INITIAL_VALUE:
				return basicSetInitialValue(null, msgs);
			case CorePackage.ATTRIBUTE__ASSOCIATION_END:
				return eBasicSetContainer(null, CorePackage.ATTRIBUTE__ASSOCIATION_END, msgs);
			case CorePackage.ATTRIBUTE__ATTRIBUTE_LINK:
				return ((InternalEList) getAttributeLink()).basicRemove(otherEnd, msgs);
			case CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE:
				return ((InternalEList) getAssociationEndRole()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CorePackage.ATTRIBUTE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CorePackage.ATTRIBUTE__OWNER:
				return eContainer.eInverseRemove(this, CorePackage.CLASSIFIER__FEATURE, Classifier.class, msgs);
			case CorePackage.ATTRIBUTE__ASSOCIATION_END:
				return eContainer.eInverseRemove(this, CorePackage.ASSOCIATION_END__QUALIFIER, AssociationEnd.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ATTRIBUTE__ELEMENT_IMPORT:
			return getElementImport();
		case CorePackage.ATTRIBUTE__NAME:
			return getName();
		case CorePackage.ATTRIBUTE__VISIBILITY:
			return getVisibility();
		case CorePackage.ATTRIBUTE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.ATTRIBUTE__NAMESPACE:
			return getNamespace();
		case CorePackage.ATTRIBUTE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CorePackage.ATTRIBUTE__CONSTRAINT:
			return getConstraint();
		case CorePackage.ATTRIBUTE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CorePackage.ATTRIBUTE__PRESENTATION:
			return getPresentation();
		case CorePackage.ATTRIBUTE__TARGET_FLOW:
			return getTargetFlow();
		case CorePackage.ATTRIBUTE__SOURCE_FLOW:
			return getSourceFlow();
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case CorePackage.ATTRIBUTE__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case CorePackage.ATTRIBUTE__COMMENT:
			return getComment();
		case CorePackage.ATTRIBUTE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case CorePackage.ATTRIBUTE__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case CorePackage.ATTRIBUTE__TAGGED_VALUE:
			return getTaggedValue();
		case CorePackage.ATTRIBUTE__BEHAVIOR:
			return getBehavior();
		case CorePackage.ATTRIBUTE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CorePackage.ATTRIBUTE__COLLABORATION:
			return getCollaboration();
		case CorePackage.ATTRIBUTE__PARTITION:
			return getPartition();
		case CorePackage.ATTRIBUTE__OWNER_SCOPE:
			return getOwnerScope();
		case CorePackage.ATTRIBUTE__OWNER:
			return getOwner();
		case CorePackage.ATTRIBUTE__MULTIPLICITY:
			return getMultiplicity();
		case CorePackage.ATTRIBUTE__CHANGEABILITY:
			return getChangeability();
		case CorePackage.ATTRIBUTE__TARGET_SCOPE:
			return getTargetScope();
		case CorePackage.ATTRIBUTE__TYPE:
			if (resolve)
				return getType();
			return basicGetType();
		case CorePackage.ATTRIBUTE__INITIAL_VALUE:
			return getInitialValue();
		case CorePackage.ATTRIBUTE__ASSOCIATION_END:
			return getAssociationEnd();
		case CorePackage.ATTRIBUTE__ATTRIBUTE_LINK:
			return getAttributeLink();
		case CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE:
			return getAssociationEndRole();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ATTRIBUTE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__NAME:
			setName((String) newValue);
			return;
		case CorePackage.ATTRIBUTE__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case CorePackage.ATTRIBUTE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.ATTRIBUTE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CorePackage.ATTRIBUTE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__BINDING:
			setBinding((Binding) newValue);
			return;
		case CorePackage.ATTRIBUTE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case CorePackage.ATTRIBUTE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__OWNER_SCOPE:
			setOwnerScope((String) newValue);
			return;
		case CorePackage.ATTRIBUTE__OWNER:
			setOwner((Classifier) newValue);
			return;
		case CorePackage.ATTRIBUTE__MULTIPLICITY:
			setMultiplicity((Multiplicity) newValue);
			return;
		case CorePackage.ATTRIBUTE__CHANGEABILITY:
			setChangeability((String) newValue);
			return;
		case CorePackage.ATTRIBUTE__TARGET_SCOPE:
			setTargetScope((String) newValue);
			return;
		case CorePackage.ATTRIBUTE__TYPE:
			setType((Classifier) newValue);
			return;
		case CorePackage.ATTRIBUTE__INITIAL_VALUE:
			setInitialValue((Expression) newValue);
			return;
		case CorePackage.ATTRIBUTE__ASSOCIATION_END:
			setAssociationEnd((AssociationEnd) newValue);
			return;
		case CorePackage.ATTRIBUTE__ATTRIBUTE_LINK:
			getAttributeLink().clear();
			getAttributeLink().addAll((Collection) newValue);
			return;
		case CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE:
			getAssociationEndRole().clear();
			getAssociationEndRole().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ATTRIBUTE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CorePackage.ATTRIBUTE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CorePackage.ATTRIBUTE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CorePackage.ATTRIBUTE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.ATTRIBUTE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CorePackage.ATTRIBUTE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CorePackage.ATTRIBUTE__CONSTRAINT:
			getConstraint().clear();
			return;
		case CorePackage.ATTRIBUTE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CorePackage.ATTRIBUTE__PRESENTATION:
			getPresentation().clear();
			return;
		case CorePackage.ATTRIBUTE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CorePackage.ATTRIBUTE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case CorePackage.ATTRIBUTE__BINDING:
			setBinding((Binding) null);
			return;
		case CorePackage.ATTRIBUTE__COMMENT:
			getComment().clear();
			return;
		case CorePackage.ATTRIBUTE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case CorePackage.ATTRIBUTE__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case CorePackage.ATTRIBUTE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CorePackage.ATTRIBUTE__BEHAVIOR:
			getBehavior().clear();
			return;
		case CorePackage.ATTRIBUTE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CorePackage.ATTRIBUTE__COLLABORATION:
			getCollaboration().clear();
			return;
		case CorePackage.ATTRIBUTE__PARTITION:
			getPartition().clear();
			return;
		case CorePackage.ATTRIBUTE__OWNER_SCOPE:
			setOwnerScope(OWNER_SCOPE_EDEFAULT);
			return;
		case CorePackage.ATTRIBUTE__OWNER:
			setOwner((Classifier) null);
			return;
		case CorePackage.ATTRIBUTE__MULTIPLICITY:
			setMultiplicity((Multiplicity) null);
			return;
		case CorePackage.ATTRIBUTE__CHANGEABILITY:
			setChangeability(CHANGEABILITY_EDEFAULT);
			return;
		case CorePackage.ATTRIBUTE__TARGET_SCOPE:
			setTargetScope(TARGET_SCOPE_EDEFAULT);
			return;
		case CorePackage.ATTRIBUTE__TYPE:
			setType((Classifier) null);
			return;
		case CorePackage.ATTRIBUTE__INITIAL_VALUE:
			setInitialValue((Expression) null);
			return;
		case CorePackage.ATTRIBUTE__ASSOCIATION_END:
			setAssociationEnd((AssociationEnd) null);
			return;
		case CorePackage.ATTRIBUTE__ATTRIBUTE_LINK:
			getAttributeLink().clear();
			return;
		case CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE:
			getAssociationEndRole().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ATTRIBUTE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CorePackage.ATTRIBUTE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CorePackage.ATTRIBUTE__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case CorePackage.ATTRIBUTE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CorePackage.ATTRIBUTE__NAMESPACE:
			return getNamespace() != null;
		case CorePackage.ATTRIBUTE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CorePackage.ATTRIBUTE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CorePackage.ATTRIBUTE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CorePackage.ATTRIBUTE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CorePackage.ATTRIBUTE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CorePackage.ATTRIBUTE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case CorePackage.ATTRIBUTE__BINDING:
			return binding != null;
		case CorePackage.ATTRIBUTE__COMMENT:
			return comment != null && !comment.isEmpty();
		case CorePackage.ATTRIBUTE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CorePackage.ATTRIBUTE__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case CorePackage.ATTRIBUTE__STEREOTYPE:
			return stereotype != null;
		case CorePackage.ATTRIBUTE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CorePackage.ATTRIBUTE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CorePackage.ATTRIBUTE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CorePackage.ATTRIBUTE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CorePackage.ATTRIBUTE__PARTITION:
			return partition != null && !partition.isEmpty();
		case CorePackage.ATTRIBUTE__OWNER_SCOPE:
			return OWNER_SCOPE_EDEFAULT == null ? ownerScope != null : !OWNER_SCOPE_EDEFAULT.equals(ownerScope);
		case CorePackage.ATTRIBUTE__OWNER:
			return getOwner() != null;
		case CorePackage.ATTRIBUTE__MULTIPLICITY:
			return multiplicity != null;
		case CorePackage.ATTRIBUTE__CHANGEABILITY:
			return CHANGEABILITY_EDEFAULT == null ? changeability != null : !CHANGEABILITY_EDEFAULT.equals(changeability);
		case CorePackage.ATTRIBUTE__TARGET_SCOPE:
			return TARGET_SCOPE_EDEFAULT == null ? targetScope != null : !TARGET_SCOPE_EDEFAULT.equals(targetScope);
		case CorePackage.ATTRIBUTE__TYPE:
			return type != null;
		case CorePackage.ATTRIBUTE__INITIAL_VALUE:
			return initialValue != null;
		case CorePackage.ATTRIBUTE__ASSOCIATION_END:
			return getAssociationEnd() != null;
		case CorePackage.ATTRIBUTE__ATTRIBUTE_LINK:
			return attributeLink != null && !attributeLink.isEmpty();
		case CorePackage.ATTRIBUTE__ASSOCIATION_END_ROLE:
			return associationEndRole != null && !associationEndRole.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // AttributeImpl
